<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        form {
            border: 1px solid #ddd;
            padding: 5px;
            width: 225px;
            background : #efefef;
        }
        label {
            display: block;
            margin-top: 5px;
        }
        input, textarea, select, option {
            min-width: 200px;
        }
    </style>
</head>
<body>
    <div id='app'>
        <h1>TEST</h1>
        <form @submit.prevent='submitForm()'>
            <p v-if='errors.length'>
                <b>Please correct the following errors</b>
                <ul>
                    <li v-for='err in errors'>{{ err }}</li>
                </ul>
            </p>
            <label>Nama : </label>
            <input type="text" name='nama' ref='nama' v-model='nama' :disabled='buttonStatus == "upload"'>
            <label>Alamat : </label>
            <textarea name="alamat" ref='alamat' v-model='alamat' :disabled='buttonStatus == "upload"'></textarea>
            <label>Nomor Telepon : </label>
            <input type="number" name='no_telp' ref='no_telp' v-model.number='no_telp' :disabled='buttonStatus == "upload"'>
            <div v-if='buttonStatus == "submit"'>
                <input type="submit" value="SUBMIT" style='margin-top: 5px;'>
            </div>
            <div v-else-if='buttonStatus == "update"'>
                <input type="button" value="UPDATE" @click='updateMember(idEditMember)' style='margin-top: 5px;'>
                <input type="button" value="CANCEL" @click='clearForm()' style='margin-top: 5px;'>
            </div>
            <div v-else-if='buttonStatus == "upload"'>
                <input type="file" name='foto' ref='foto'>
                <input type="button" value="UPLOAD" @click='submitFoto(idUploadMember)' style='margin-top: 5px;'>
                <input type="button" value="CANCEL" @click='clearForm()' style='margin-top: 5px;'>
            </div>
        </form>
        <br><br>
        <table border=1>
            <tr v-for='member in members'>
                <td>
                    <img width=100 :src="member.photo_profile ? photoDomain + member.photo_profile : 'https://dummyimage.com/16:9x1080'" alt="">
                </td>
                <td>
                    <b>Name : </b> {{ member.name }} <br>
                    <b>Address : </b> {{ member.address }}  <br>
                    <b>No Telp : </b> {{ member.no_hp }}
                </td>
                <td>
                    <button @click='editMember(member)'>Edit</button>
                    <button @click='removeMember(member.id)'>Hapus</button>
                    <button @click='uploadFoto(member)'>Upload Foto</button>
                </td>
            </tr>

        </table>
    </div>
    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script>
        var vm = new Vue({
            el: '#app',
            data: {
                nama: '',
                alamat: '',
                no_telp: '',
                errors: [],
                members: [],
                photoDomain: 'http://demo-api-vue.sanbercloud.com',
                buttonStatus: 'submit',
                idEditMember: null,
                idUploadMember: null
            },
            methods: {
                validationForm : function(){
                    this.errors = []

                    if(this.nama.length === 0){
                        this.errors.push('Harap isikan nama')
                        this.$refs.nama.focus()
                    }
                    if(this.alamat.length === 0){
                        this.errors.push('Harap isikan alamat')
                        this.$refs.alamat.focus()
                    }
                    if(this.no_telp.length === 0){
                        this.errors.push('Harap isikan nomor telepon')
                        this.$refs.no_telp.focus()
                    }
                },

                clearForm : function(){
                    this.nama = ''
                    this.alamat = ''
                    this.no_telp = ''
                    this.buttonStatus = 'submit'
                    this.idEditMember = null
                    this.idUploadMember = null
                },

                submitForm : function(){
                    this.validationForm()
                    if(this.errors.length === 0){
                        let formData = new FormData()
                        formData.append('name', this.nama)
                        formData.append('address', this.alamat)
                        formData.append('no_hp', this.no_telp)
                        const config = {
                            method: 'post',
                            url: 'http://demo-api-vue.sanbercloud.com/api/member',
                            data: formData
                        }
                        axios(config)
                            .then( (response) => {
                                this.clearForm()
                                this.getMembers()
                                alert(response.data.message)
                            })
                            .catch( () => {
                            console.log(error)      
                            })                        
                    }
                },

                getMembers : function(){
                    const config = {
                        method: 'get',
                        url: 'http://demo-api-vue.sanbercloud.com/api/member'
                    }
                    axios(config)
                        .then( (response) => {
                            this.members = response.data.members
                            console.log(this.members)
                        })
                        .catch( () => {
                            console.log(error)
                        })
                },

                removeMember : function(id){
                    const config = {
                        method: 'post',
                        url: `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                        params: { _method : 'DELETE'}
                    }
                    axios(config)
                        .then( (response) => {
                            this.getMembers()
                            alert(response.data.message)
                        })
                        .catch( () => {
                            console.log(error)
                        })
                },

                editMember : function(member){
                    this.nama = member.name
                    this.alamat = member.address
                    this.no_telp = member.no_hp
                    this.buttonStatus = 'update'
                    this.idEditMember = member.id
                },

                updateMember : function(id){
                    this.validationForm()
                    if(this.errors.length === 0){
                        let formData = new FormData()
                        formData.append('name', this.nama)
                        formData.append('address', this.alamat)
                        formData.append('no_hp', this.no_telp)
                        let config = {
                            method: 'post',
                            url: `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                            params: { _method : 'PUT'},
                            data: formData
                        }

                        axios(config)
                            .then( (response) => {
                                this.clearForm()
                                this.getMembers()
                                alert(response.data.message)
                            })
                            .catch( () => {
                                console.log(error)
                            })
                        }
                },
                
                uploadFoto : function(member){
                    this.nama = member.name
                    this.alamat = member.address
                    this.no_telp = member.no_hp
                    this.buttonStatus = 'upload'
                    this.idUploadMember = member.id
                },

                submitFoto : function(id){
                    let file = this.$refs.foto.files[0]
                    let formData = new FormData()
                    formData.append('photo_profile', file)
                    let config = {
                        method: 'post',
                        url: `http://demo-api-vue.sanbercloud.com/api/member/${id}/upload-photo-profile`,
                        data: formData
                    }
                    axios(config)
                        .then( (response) => {
                            this.clearForm()
                            this.getMembers()
                            alert(response.data.message)
                        })
                        .catch( (error) => {
                            console.log(error)
                        })
                }
            },
            created(){
                this.getMembers()
            }
        })
    </script>
</body>
</html>